/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -----------------------------
  Terminal-Emulation fuer Linux
  -----------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>
#include <stdarg.h>
#include <stdlib.h>
#include "term_l.h"

char endstr[200]="";
int curses_on=0;

void endmessage( char *string, ...)
{ va_list argpoint;

  va_start(argpoint,string);
  vsprintf(endstr,string,argpoint);
  va_end(argpoint);

  exit(0);
}

void te_end(void)
{
  if(curses_on)
    endvideo();
  if(endstr[0])
    printf("bct: %s\n", endstr);
}

int main(int argc,char *argv[])
{ char s[256]="";
  int i;

  atexit(te_end);
  initvideo();
  curses_on=1;

  if (argc > 2)
    endmessage("OpenBCM BCT v"VNUMMER" - Usage:  %s [<remote host>]\n", argv[0]);
  else if (argc == 1)
    init_sock("localhost");
  else
    init_sock(argv[1]);

  while(1)
  {
    int a;
    fd_set fds;
    struct timeval timeout;

    do
    {
      a=holsock();
      if(a!=EOF)
      {
        putv_cur(a);
      }
    } while(a!=EOF);
    putflush_cur();

    if(scankey(s))
    { if(s[0]==':')
      {
        //te_readcmd(s);
	s[0]=0;
      }
      else
      { for(i=0;s[i];i++)
          putv_sock(s[i]);
        putv_sock(13);
        putflush_sock();
        s[0]=0;
      }
    }

    FD_ZERO(&fds);
    timeout.tv_sec=0;
    timeout.tv_usec=20000L;
    select(2,&fds,NULL,NULL,&timeout);
  }
  return(0);
}
